#
#
# $Id: gtkrss.rb,v 1.2 2004/02/10 13:47:36 Yuukis Exp $
#
#

class RSSFrame < Gtk::ScrolledWindow

	attr_reader :id, :dat, :category_string, :description, :close, :next, :prev

	def initialize(category_string)
		@category_string = category_string
		cregex = /<>#{category_string}$/
		CFG::RSS.sites.each {|sites_hash|
			if sites_hash.keys.to_s =~ cregex
				category = sites_hash.keys.to_s
				@id = category.gsub(/<>.*/, '')
				@dat = @id + '.rss'
				@description = CFG::NLS.rss_pre + id + CFG::NLS.rss_post

				rsss = []
				sites_hash[category].each {|site|
					rsss << TinyRSS.new(site['site'], site['uri_top'], site['uri_rss'], site['dir'])
				}
				@rsss = RSSS.new(@id, rsss)
			end
		}

		@rss_hash = {}
		@vadj = Gtk::Adjustment.new(0, 0, 0, 0, 0, 0)

		@clist = Gtk::CList.new(['', '', '', 'site', 'title'])  # num, state, cache ..
		@clist.set_selection_mode(Gtk::SELECTION_BROWSE)
		@clist.set_usize(1, 1)
		@clist.add_vikey_events(@vadj)

		(0..4).each {|x| @clist.set_column_auto_resize(x, true) }
		(3..4).each {|x| @clist.set_column_justification(x, Gtk::JUSTIFY_LEFT) }
		@clist.set_column_justification(0, Gtk::JUSTIFY_RIGHT)

=begin
		@clist.signal_connect('key_press_event') {|w, e|
			case e.keyval
			when Gdk::GDK_a
				r = 0
				@clist.each_selection {|row| r = row }
				@bbs_board.bookmark.toggle(@thread_hash[@clist.get_text(r, 0)])
				coloring
			when Gdk::GDK_d
				r = 0
				@clist.each_selection {|row| r = row }
				@bbs_board.abone.toggle(@thread_hash[@clist.get_text(r, 0)])
				if @bbs_board.abone.include?(@thread_hash[@clist.get_text(r, 0)])
					@clist.remove_row(r)
				else
					coloring
				end
				@clist.select_row(r, 0)
			when Gdk::GDK_D
				if mode == 'past'
					r = 0
					@clist.each_selection {|row| r = row }
					@bbs_board.trash(@thread_hash[@clist.get_text(r, 0)])
					@clist.remove_row(r)
					@clist.select_row(r, 0)
				end
			when Gdk::GDK_equal then check('cache_plus')
			when Gdk::GDK_s then check('update')
			end
		}

		@clist.signal_connect('click_column') {|w, c|
			case c
			when 0 then refresh
			when 1 then check('update')
			when 3 then check('cache_plus')
			end
		}
=end

		get(@rsss.get)

		super(nil, @vadj)
		self.set_policy(Gtk::POLICY_NEVER, Gtk::POLICY_ALWAYS)
		self.add @clist
	end

	def get(rss_hashes)
		@clist.freeze
		@clist.clear
		@rss_hash.clear
		n = 0
		rss_hashes.each {|rss|
			n += 1
			@clist.append([n.to_s, rss['state'], rss['cache'], rss['site'], rss['title']])
			@rss_hash[n.to_s]= rss['link']
		}
		@clist.thaw
	end

	def update(get = true)
		array = @rsss.get(get)
		get(array)
	end

	def find(word)
		get(@rsss.get_find(word))
	end

	def rollback
		@rsss.rollback
	end

	def check(flag)
		if @rsss.flags[flag]
			@rsss.flags[flag] = false
		else
			@rsss.flags[flag] = true
		end
		update(false)
	end

	def cached(row)
		@clist.set_text(row, 2, 'C')
		@rsss.cached(@rss_hash[@clist.get_text(row, 0)])
	end

	def label
		case CFG::UIF.tabbutton_type
		when 0
			label = Gtk::Label.new('RS' + String2ch.trunc("S@#{@category_string}"))  # ܥ󤬤ʤẸ
			label.show_all
			return([label])
		when 1
			label = Gtk::Label.new('RS' + String2ch.trunc("S@#{@category_string}") + ' ')  # not yet. (w
			@close = Gtk::Button.new.add Pix.get('close')
			box = Gtk::HBox.new
			box.pack_start label
			box.pack_start @close, false
			box.show_all
			return([box, @close])
		else
			label = Gtk::Label.new('RS' + String2ch.trunc("S@#{@category_string}") + ' ')
			@close = Gtk::Button.new.add Pix.get('close')
			@next = Gtk::Button.new.add Pix.get('next')
			@prev = Gtk::Button.new.add Pix.get('prev')
			box = Gtk::HBox.new
			box.pack_start label
			box.pack_start @prev, false
			box.pack_start @close, false
			box.pack_start @next, false
			box.show_all
			return([box, @close, @prev, @next])
		end
	end

	def child
		@clist
	end

	def link(id)
		@rss_hash[id]
	end
end
